unit Find;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, StrUtils, Menus, LMDCustomComboBox,
  LMDComboBox, LMDCustomControl, LMDCustomPanel, LMDCustomBevelPanel,
  LMDBaseEdit, LMDCustomEdit, LMDEdit, ExtCtrls, INIfiles;

type
  TfrmFind = class(TForm)
    Label1: TLabel;
    GroupBoxResults: TGroupBox;
    ListViewFind: TListView;
    btnStartSearch: TButton;
    Label2: TLabel;
    btnCancel: TButton;
    StatusBar: TStatusBar;
    mnuPopUp: TPopupMenu;
    mnuPopUpCopyAsText: TMenuItem;
    txtFind: TLMDEdit;
    cbCols: TLMDComboBox;
    mnuPopUpCopyAsHTML: TMenuItem;
    Bevel2: TBevel;
    N1: TMenuItem;
    mnuPopupCopySourceIPAddress: TMenuItem;
    mnuPopupCopyDestinationIPAddress: TMenuItem;
    Bevel1: TBevel;
    ProgressBarFind: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure btnStartSearchClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure ListViewFindDblClick(Sender: TObject);
    procedure ListViewFindSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListViewFindKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListViewFindMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuPopUpCopyAsTextClick(Sender: TObject);
    procedure Selectall2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuPopUpCopyAsHTMLClick(Sender: TObject);
    procedure mnuPopUpPopup(Sender: TObject);
    procedure mnuPopupCopySourceIPAddressClick(Sender: TObject);
    procedure mnuPopupCopyDestinationIPAddressClick(Sender: TObject);
    procedure ListViewFindCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    gHasBeenShown : boolean; // hller koll p om fnstret har visats eller icke
  end;

var
  frmFind: TfrmFind;



// mina funkisar
//procedure showDetailsWindow;
procedure AktiveraInaktiveraMenyVal;


implementation

uses Main, Details;


{$R *.dfm}

procedure TfrmFind.FormCreate(Sender: TObject);
var
    i : integer;
begin

    // lgg in vrden i
    cbCols.Clear;
    cbCols.Items.Add('All');
    // dock inte # fr den gr inte att ska p..eh..
    for i := 1 to frmMain.ListviewLog.Columns.Count-1 do begin
        cbCols.Items.Add( frmMain.ListviewLog.Columns.Items[i].Caption );
    end;

    cbCols.ItemIndex:=0;

end;

procedure TfrmFind.btnStartSearchClick(Sender: TObject);
var
    strFind, strTmp : string;
    findColumn : integer;
    i,j,k     : integer;
begin

    // let's rock and roll!

    // rensa listan
    ListViewFind.Clear;
    // snabbar upp
    ListViewFind.Items.BeginUpdate;
    // muspekare
    screen.Cursor := crHourGlass;

    // meddela att vi sker
    StatusBar.Panels.Items[0].Text := 'Searching ...';

    // text att ska efter
    strFind := txtFind.Text;

    // i vilken kolumn?
    findColumn := cbCols.ItemIndex; // - 1 fr att frst f bort "all" som inte r en kolumn och sen fr att
    // col 0 ->caption, col 1 -> strings[0]

    if findColumn >= 1 then begin
        // denna anvnds fr cbCols.itemindex > 2
        // loopa igenom listview'n och skriv ut alla som matchar
//        findColumn := findColumn - 1;
//showmessage('sker i col: ' + IntToStr(findColumn) );
        // mappa om findColumn fr att matcha getFromLog's nummer...god it's stoopid! :(
        case findColumn of
            1: findColumn := findColumn;
            2: findColumn := 10;
            3: findColumn := 2;
            4: findColumn := 3;
            5: findColumn := 4;
            6: findColumn := 5;
            7: findColumn := 6;
            8: findColumn := 7;
            9: findColumn := 8;
           10: findColumn := 9;
        end;

        for i:=0 to gLogFileFiltered.Count-1 do begin

            strTmp := getFromLog(findColumn, i, true);

            // ka progressbaren
            if ((i*100 DIV gLogFileFiltered.Count) mod 10 ) = 0 then begin
                ProgressBarFind.Position := (i * 100) div gLogFileFiltered.Count;
            end;

            if AnsiContainsText(strTmp, strFind) = true then begin
                // det vi skte fanns hr, lgg till det i ListView'n
                with listviewfind.Items.Add do begin
                    Caption := getFromLog(1, i, true);
                    SubItems.Add( getFromLog(10, i, true) );
                    SubItems.Add( getFromLog(2, i, true) );
                    SubItems.Add( getFromLog(3, i, true) );
                    SubItems.Add( getFromLog(4, i, true) );
                    SubItems.Add( getFromLog(5, i, true) );
                    SubItems.Add( getFromLog(6, i, true) );
                    SubItems.Add( getFromLog(7, i, true) );
                    SubItems.Add( getFromLog(8, i, true) );
                    SubItems.Add( getFromLog(9, i, true) );
                end; // with
            end; // if contains
        end;
    end // if findcol...

    // 0 = leta i alla flt
    else if findColumn = 0 then begin

        // loopa igenom listview'n och skriv ut alla som matchar
        for i:=0 to gLogFileFiltered.Count-1 do begin

            // ka progressbaren
            if ((i*100 DIV gLogFileFiltered.Count) mod 10 ) = 0 then begin
                ProgressBarFind.Position := (i * 100) div gLogFileFiltered.Count;
            end;

            if AnsiContainsText( gLogFileFiltered.Strings[i], strFind) then begin
                // det vi skte fanns hr, lgg till det i ListView'n
                with listviewfind.Items.Add do begin
                    Caption := getFromLog(1, i, true);
                    SubItems.Add( getFromLog(10, i, true) );
                    SubItems.Add( getFromLog(2, i, true) );
                    SubItems.Add( getFromLog(3, i, true) );
                    SubItems.Add( getFromLog(4, i, true) );
                    SubItems.Add( getFromLog(5, i, true) );
                    SubItems.Add( getFromLog(6, i, true) );
                    SubItems.Add( getFromLog(7, i, true) );
                    SubItems.Add( getFromLog(8, i, true) );
                    SubItems.Add( getFromLog(9, i, true) );
                end; // with

            end; // if ansiContains...

        end;

    end;

    // uppdatera igen
    ListViewFind.Items.EndUpdate;
    // mouse back
    Screen.Cursor := CrDefault;

    // skriv hur mnga trffar
    StatusBar.Panels.Items[0].Text := 'Found ' + IntToStr(ListViewFind.Items.Count) + ' matches.';

    // stt progressbar till 100 s det syns att vi e klara med skningen
    ProgressBarFind.Position := 100;

end;

procedure TfrmFind.btnCancelClick(Sender: TObject);
begin

    // hm
    Hide;

end;

procedure TfrmFind.ListViewFindDblClick(Sender: TObject);
begin

    frmMain.showDetailsWindow(frmFind);

end;

procedure TfrmFind.ListViewFindSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
    tmp : string;
begin

// blir fel ibland, fattar inte varfr .. :( kr try fr skerhets skull
try
    // uppdatera vrden i details-fnstret
    frmDetails.txtPermitBlock.text := Item.caption; // permitted/blocked
    frmDetails.txtDirection.text := Item.SubItems.Strings[0]; // direction
    frmDetails.txtDate.text := Item.SubItems.Strings[1]; // date
    frmDetails.txtRule.text := Item.SubItems.Strings[2]; // rule
    frmDetails.txtProtocol.text := Item.SubItems.Strings[3]; // source

    // stt in en ny rad fre [ s det blir lttare att lsa
    tmp := Item.SubItems.Strings[4];
    if Pos('[', tmp) > 0 then begin
        tmp := StringReplace(tmp, '[', #13#10+'[', []);
    end;

    frmDetails.txtSourceAdress.text := tmp; // source
    frmDetails.txtSourcePort.text := Item.SubItems.Strings[5];

    // stt in en ny rad fre [ s det blir lttare att lsa
    tmp := Item.SubItems.Strings[6];
    if Pos('[', tmp) > 0 then begin
        tmp := StringReplace(tmp, '[', #13#10+'[', []);
    end;
    frmDetails.txtDestinationAdress.text := tmp; //
    frmDetails.txtDestinationPort.text := Item.SubItems.Strings[7]; //
    frmDetails.txtOwner.text := Item.SubItems.Strings[8]; //
except
end;

end;

procedure TfrmFind.ListViewFindKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//showmessage('key down');

    // ctrl + c = copy
    if (key = 67) and (Shift = [ssCtrl]) then begin
        frmMain.CopySelectedAsText(ListViewFind);
    end;

    // markera allt
    if (Shift = [ssCtrl]) and (key = 65) then begin
        ListViewFind.SelectAll;
    end;

    // r det ctrl + d vi trycker s ska details-fnstret visar
    if (key = 68) and (Shift = [ssCtrl]) then begin
        frmMain.showDetailsWindow(frmFind);
    end;

    // knappen bredvid hgra windowstangenten..
    if (key = 93) then begin
        frmFind.mnuPopUp.popup((ListViewFind.Width DIV 2)+frmFind.Left, frmFind.top+frmFind.ListViewFind.Top+frmFind.GroupBoxResults.Top+(frmFind.ListViewFind.height div 2));
    end;

end;



{procedure showDetailsWindow;
begin
// visa details-fnstret
    if frmDetails.Showing = true then begin
        frmDetails.Hide;
    end
    else begin
        frmDetails.Show;
        frmFind.SetFocus;
    end;
end;
 }


procedure TfrmFind.ListViewFindMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{
    // mste kolla om det var hger musknapp som trycktes
    if (Button = mbRight) then begin
        // det var hger... visa meny
        x := frmFind.Left + 29 + x;
        y := frmFind.Top  + frmFind.ListViewFind.Top + 108 + y;
        frmFind.mnuPopUp.Popup(X, Y);
    end;
 }
end;

procedure TfrmFind.mnuPopUpCopyAsTextClick(Sender: TObject);
begin
    frmMain.CopySelectedAsText(ListViewFind);
end;

procedure TfrmFind.Selectall2Click(Sender: TObject);
begin
        ListViewFind.SelectAll;
end;

procedure TfrmFind.FormActivate(Sender: TObject);
var
    filen : TIniFile;
begin

    // fult som fan antar jag, men det funkar:
    // byt meny p huvudformulret till en likadan meny fast utan kortkommandon - annars fr jag inte kortkommandona p detta formulr att funka :( 
    frmMain.Menu := frmMain.MenuEmpty;

    // ndra ev. storlek
    // ls in instllningar
    if gHasBeenShown = false then begin
      filen := TIniFile.Create(gProgramPath + 'TinyLogger.ini');

      frmFind.Left:=filen.ReadInteger('FindWindow','WindowPosLeft',100);
      frmFind.Top:=filen.ReadInteger('FindWindow','WindowPosTop',100);
      frmFind.Width:=filen.ReadInteger('FindWindow','WindowPosWidth',669);
      frmFind.Height:=filen.ReadInteger('FindWindow','WindowPosHeight',352);

       if filen.ReadBool('FindWindow','WindowPosMaximized',false) = true then
         frmFind.WindowState := wsMaximized;

       filen.free;

       gHasBeenShown := true;
    end;

end;

procedure TfrmFind.mnuPopUpCopyAsHTMLClick(Sender: TObject);
begin
    frmMain.CopySelectedAsHTML(ListViewFind);
end;


// aktiverar menyval  snt p frmFind
procedure AktiveraInaktiveraMenyVal;
begin

    if frmFind.ListViewFind.SelCount > 0 then begin
        // finns valda saker
        frmFind.mnuPopUpCopyAsText.Enabled := true;
        frmFind.mnuPopUpCopyAsHTML.Enabled := true;
        frmFind.mnuPopupCopySourceIPAddress.Enabled := true;
        frmFind.mnuPopupCopyDestinationIPAddress.Enabled := true;
    end
    else begin
        // inga valda saker
        frmFind.mnuPopUpCopyAsText.Enabled := false;
        frmFind.mnuPopUpCopyAsHTML.Enabled := false;
        frmFind.mnuPopupCopySourceIPAddress.Enabled := false;
        frmFind.mnuPopupCopyDestinationIPAddress.Enabled := false;

    end;

end;

procedure TfrmFind.mnuPopUpPopup(Sender: TObject);
begin
    // menyval aktiva eller icke
    AktiveraInaktiveraMenyVal;
end;

procedure TfrmFind.mnuPopupCopySourceIPAddressClick(Sender: TObject);
begin
    frmMain.copyAdressWithRemovedDNSname(frmFind.ListViewFind.ItemFocused.SubItems.Strings[4] );
end;

procedure TfrmFind.mnuPopupCopyDestinationIPAddressClick(Sender: TObject);
begin
    frmMain.copyAdressWithRemovedDNSname(frmFind.ListViewFind.ItemFocused.SubItems.Strings[6] );
end;

procedure TfrmFind.ListViewFindCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin

    // ndra bakgrundsfrg beroende p block el. permit
    if (gShowColoredLog.enabled = true) then begin
        if (Item.Caption = 'Permitted') then
            Sender.Canvas.Brush.Color := gShowColoredLog.PermitBack
        else
            Sender.Canvas.Brush.Color := gShowColoredLog.BLockBack;
    end;

    // ndra font om vi valt det
    if (gShowColoredLog.enabled = true) then begin
        if (Item.Caption = 'Permitted') then
            Sender.Canvas.Font.Color := gShowColoredLog.PermitText
        else
            Sender.Canvas.Font.Color := gShowColoredLog.BlockText;
    end;

end;

end.
