unit Settings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, LMDCustomComponent,
  LMDContainerComponent, LMDBaseDialog, LMDDirDlg, LMDCustomControl,
  LMDCustomPanel, LMDCustomBevelPanel, LMDBaseEdit, LMDCustomEdit,
  LMDCustomBrowseEdit, LMDFileOpenEdit, LMDAboutDlg, LMDWndProcComponent,
  LMDTrayIcon, Spin, lmdstdcA, Mask, ExtCtrls;

type
  TfrmSettings = class(TForm)
    OpenDialog1: TOpenDialog;
    btnOk: TButton;
    btnCancel: TButton;
    PageControl: TPageControl;
    TabLogFile: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    txtLogfileLocation: TEdit;
    btnBrowseLogfile: TButton;
    cbShow: TComboBox;
    cbAutoReload: TCheckBox;
    cbOnlyLoadLatestEntries: TCheckBox;
    UpDownLoadLatest: TUpDown;
    lbNumberToLoad: TLabel;
    Label4: TLabel;
    txtLoadLatestEntries: TEdit;
    cbShowDirection: TComboBox;
    cbShowPermittedOrBlocked: TComboBox;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TabSheet1: TTabSheet;
    GroupBox3: TGroupBox;
    cbShowGridLines: TCheckBox;
    cbShowColoredLog: TCheckBox;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    lbInvisible: TLabel;
    lbVisible: TLabel;
    cbAlphaBlend: TCheckBox;
    ScrollBar: TScrollBar;
    cbSaveWindowPos: TCheckBox;
    cbSaveColumnSize: TCheckBox;
    cbUseFlatScrollbars: TCheckBox;
    cbUseFlatComboBox: TCheckBox;
    lbColor1: TLabel;
    lbColor4: TLabel;
    ColorBoxPermittedText: TColorBox;
    lbColor2: TLabel;
    Label10: TLabel;
    lbColor3: TLabel;
    ColorBoxPermittedBackground: TColorBox;
    Label12: TLabel;
    Label13: TLabel;
    lbColor6: TLabel;
    lbColor5: TLabel;
    ColorBoxBlockedText: TColorBox;
    ColorBoxBlockedBackground: TColorBox;
    groupBoxSortin: TGroupBox;
    lbSortingDirection: TLabel;
    lbSortingColumn: TLabel;
    cbSortDirection: TComboBox;
    cbSortOnStart: TCheckBox;
    cbSortColumn: TComboBox;
    procedure btnBrowseLogfileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbSortOnStartClick(Sender: TObject);
    procedure cbAlphaBlendClick(Sender: TObject);
    procedure cbOnlyLoadLatestEntriesClick(Sender: TObject);
    procedure lblShowColoredLogClick(Sender: TObject);
    procedure cbShowColoredLogClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSettings: TfrmSettings;

implementation

uses main;

{$R *.dfm}

procedure TfrmSettings.btnBrowseLogfileClick(Sender: TObject);
begin

    // visa dialogruta fr att ppna
    OpenDialog1.DefaultExt := 'log';
    OpenDialog1.Filter     := 'Logfiles (*.log)|*.log|All files (*.*)|.*';

    // tryckte anv. ok eller inte
    if OpenDialog1.Execute then begin
        txtLogfileLocation.Text := OpenDialog1.FileName;
    end;

end;

procedure TfrmSettings.FormCreate(Sender: TObject);
var
    i : integer;
begin

    // fyll show-boxarna med vrdena frn huvudformulret
    frmSettings.cbShow.Items := frmMain.cbShow.Items;
    frmSettings.cbShowDirection.Items := frmMain.cbShowDirection.Items;
    frmSettings.cbShowPermittedOrBlocked.Items := frmMain.cbShowPermittedOrBlocked.Items;

    // fyll i comboboxen med kolumn-rubrikerna
    frmSettings.cbSortColumn.Clear;
    for i:=0 to frmMain.ListviewLog.Columns.Count-1 do begin
        frmSettings.cbSortColumn.Items.Add( frmMain.ListviewLog.Columns.Items[i].Caption );
    end;

end;

procedure TfrmSettings.cbSortOnStartClick(Sender: TObject);
begin

    // aktivera sorterings-val
    if frmSettings.cbSortOnStart.Checked = true then begin
        frmSettings.cbSortDirection.Enabled := true;
        frmSettings.cbSortColumn.Enabled  := true;
        frmSettings.lbSortingDirection.Enabled := true;
        frmSettings.lbSortingColumn.Enabled := true;
    end
    else begin
        frmSettings.cbSortDirection.Enabled := false;
        frmSettings.cbSortColumn.Enabled  := false;
        frmSettings.lbSortingDirection.Enabled := false;
        frmSettings.lbSortingColumn.Enabled := false;
    end;


end;

procedure TfrmSettings.cbAlphaBlendClick(Sender: TObject);
begin

    // aktivera/inaktivera scrollbar
    if frmSettings.cbAlphaBlend.checked then begin
        frmSettings.ScrollBar.Enabled   := true;
        frmSettings.lbInvisible.Enabled := true;
        frmSettings.lbVisible.Enabled   := true;
    end
    else begin
        frmSettings.ScrollBar.Enabled   := false;
        frmSettings.lbInvisible.Enabled := false;
        frmSettings.lbVisible.Enabled   := false;
    end;


end;

procedure TfrmSettings.cbOnlyLoadLatestEntriesClick(Sender: TObject);
begin

    // ndra lite enabled-grejs
    if frmSettings.cbOnlyLoadLatestEntries.Checked = true then begin
        frmSettings.txtLoadLatestEntries.Enabled := true;
        self.UpDownLoadLatest.Enabled := true;
        self.lbNumberToLoad.Enabled := true;
    end
    else
    begin
        frmSettings.txtLoadLatestEntries.Enabled := false;
        self.UpDownLoadLatest.Enabled := false;
        self.lbNumberToLoad.Enabled := false;
    end;

end;

procedure TfrmSettings.lblShowColoredLogClick(Sender: TObject);
begin
self.cbShowColoredLog.Checked := not self.cbShowColoredLog.Checked;
end;

procedure TfrmSettings.cbShowColoredLogClick(Sender: TObject);
begin

    // aktivera/inaktivera
    if frmSettings.cbShowColoredLog.Checked = true then begin
        // aktivera
        ColorBoxPermittedText.Enabled := true;
        ColorBoxPermittedBackground.Enabled := true;
        ColorBoxBlockedText.Enabled := true;
        ColorBoxBlockedBackground.Enabled := true;
        lbColor1.Enabled := true;
        lbColor2.Enabled := true;
        lbColor3.Enabled := true;
        lbColor4.Enabled := true;
        lbColor5.Enabled := true;
        lbColor6.Enabled := true;

    end
    else begin
        // inaktivera
        ColorBoxPermittedText.Enabled := false;
        ColorBoxPermittedBackground.Enabled := false;
        ColorBoxBlockedText.Enabled := false;
        ColorBoxBlockedBackground.Enabled := false;
        lbColor1.Enabled := false;
        lbColor2.Enabled := false;
        lbColor3.Enabled := false;
        lbColor4.Enabled := false;
        lbColor5.Enabled := false;
        lbColor6.Enabled := false;
    end;

end;

end.
