unit Stats;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, LMDCustomComponent, LMDOneInstance, Menus,
  ExtCtrls, INIFiles;

type
  TfrmStats = class(TForm)
    GroupBoxSource: TGroupBox;
    ListViewSourceAddress: TListView;
    ListViewSourcePort: TListView;
    Label6: TLabel;
    lblSourcePort: TLabel;
    GroupBoxDestination: TGroupBox;
    Label2: TLabel;
    lblDestinationPort: TLabel;
    ListViewDestinationAddress: TListView;
    GroupBoxRuleProtocol: TGroupBox;
    ListViewRule: TListView;
    Label1: TLabel;
    lblRuleProtocol: TLabel;
    ListViewProtocol: TListView;
    ListViewDestinationPort: TListView;
    mnuPopupMenu1: TPopupMenu;
    mnuPopUpCopyIPAddress: TMenuItem;
    mnuPopUpSearchIPAddress: TMenuItem;
    mnuPopupMenu2: TPopupMenu;
    mnuPopUp2CopyName: TMenuItem;
    mnuPopUp2SearchName: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    Bevel2: TBevel;
    ProgressBar: TProgressBar;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure mnuPopUpCopyIPAddressClick(Sender: TObject);
    procedure mnuPopUp2CopyNameClick(Sender: TObject);
    procedure mnuPopUpSearchIPAddressClick(Sender: TObject);
    procedure mnuPopUp2SearchNameClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListViewRuleDblClick(Sender: TObject);
    procedure ListViewProtocolDblClick(Sender: TObject);
    procedure ListViewSourceAddressDblClick(Sender: TObject);
    procedure ListViewSourcePortDblClick(Sender: TObject);
    procedure ListViewDestinationAddressDblClick(Sender: TObject);
    procedure ListViewDestinationPortDblClick(Sender: TObject);
    procedure ListViewRuleContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure ListViewProtocolContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure ListViewSourceAddressContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure ListViewSourcePortContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure ListViewDestinationAddressContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure ListViewDestinationPortContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
    procedure doubleClickSearch(sender: TObject; inColumn : integer);
    procedure activeMenusIfSomethingIsChosen(Sender: TObject);
  public
    { Public declarations }
    gHasBeenShown : boolean; // r denna 0 s r det frsta gngen formulret ppnas. eller false menar jag sklart.
    procedure UppdateraStats;
  end;

var
  frmStats: TfrmStats;



// mina procedurer och funktioner
procedure getStats(sourceCol : integer; destListView : TListView);
function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;


// formulrglobala variabler
var
    gAlreadyLoaded : boolean;


implementation

uses Main, Find;

{$R *.dfm}


procedure getStats(sourceCol : integer; destListView : TListView);
var
    i, j, intTmp : integer;
    strTmp : string;
    fromText : string;
    doExists : boolean;
    existsAtRow : integer;
begin

    // 2002-05-19
    // ny kod som anvnder gLogFileFiltered istllet fr listvien p huvudformulret
    // ...snabbare, hoppas jag iaf..

    // fr varje 'entry' i loggen som visas
    for i:=0 to gLogFileFiltered.Count-1 do begin

        fromText := getFromLog(sourceCol, i, true);

        // ta reda p om fromText redan r inskriven i listview'n
        doExists := false; // utg frn att den inte finns
        existsAtRow := -1; // utg frn att den inte finns p en viss rad
        // loopa igenom hela listview'n
        j := 0;
        while (j < destListView.Items.Count) and (doExists=false) do begin
            // r denna rad samma som fromText?
            if destListView.Items[j].SubItems.Strings[0] = fromText then begin
                // japp..samma
                doExists := true;
                existsAtRow := j;
            end;
            Inc(j); // ka j
        end;

        // beroende p om den redan fanns eller inte...
        if doExists = true then begin
            // den fanns, ndra bara antal p angiven rad
            destListView.Items.Item[existsAtRow].Caption := IntToStr( StrToInt(destListView.Items.Item[existsAtRow].Caption) + 1);
        end
        else if doExists = false then begin
            // den fanns inte, lgg in ny
            with destListView.Items.Add do begin
                Caption := '1';
                SubItems.Add( fromText );
            end;
        end;


    end;

end;

procedure TfrmStats.Button1Click(Sender: TObject);
begin

    frmStats.UppdateraStats;

end;

// custom sort fr att sortera nummer korrekt
function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin
  Result := Ord( StrToInt(Item1.Caption) < StrToInt(Item2.Caption) );
end;


procedure TfrmStats.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

    // stnger formulret om esc trycks
    if Ord(key) = 27 then
	    frmStats.Close;

end;

procedure TfrmStats.FormResize(Sender: TObject);
var
    mitten, right, rightLeft, rightWidth, leftWidth : integer;
    height, top, heightGroupbox, mellanrum, bredd : integer;
begin

    // mh...gra om denhr


    // hjden p boxarna
    top     := 48; // 48 pixlar's plats fr knapparna
    height  := frmStats.Height - 108; //125 - lite plats..
    heightGroupbox := height div 3; // hur mycket hjd varje groupbox har att leka med
    mellanrum := 10; // mellan varje groupbox

    // stt nya vrden p top, width, height
    self.GroupBoxRuleProtocol.Height := heightGroupbox;

    self.GroupBoxSource.Top         := heightGroupbox + mellanrum + top;
    self.GroupBoxSource.height      := heightGroupbox;

    self.GroupBoxDestination.Top    := (heightGroupbox * 2) + (mellanrum*2) + top;
    self.GroupBoxDestination.Height := heightGroupbox;

    // bredden p boxarna
    mitten := self.GroupBoxRuleProtocol.Width - self.GroupBoxRuleProtocol.Left;
    bredd := (mitten div 2) - 18;

    ListViewRule.Width := bredd;
    ListViewProtocol.Left := bredd+30;
    ListViewProtocol.Width := bredd;

    ListViewSourceAddress.Width := bredd;
    ListViewSourcePort.Left := bredd+30;
    ListViewSourcePort.Width := bredd;

    ListViewDestinationAddress.Width := bredd;
    ListViewDestinationPort.Left := bredd+30;
    ListViewDestinationPort.Width := bredd;

    lblRuleProtocol.left := bredd+30;
    lblSourcePort.left := bredd+30;
    lblDestinationPort.left := bredd+30;

end;

procedure TfrmStats.mnuPopUpCopyIPAddressClick(Sender: TObject);
begin

    // kopiera
    frmMain.copyAdressWithRemovedDNSname( TListView(ActiveControl).Selected.SubItems.Strings[0] );

end;



procedure TfrmStats.mnuPopUp2CopyNameClick(Sender: TObject);
var
    vald : TWinControl;
begin

    // kopiera
    frmMain.CopyTextToClipboard ( TListView(ActiveControl).Selected.SubItems.Strings[0] );

end;

procedure TfrmStats.mnuPopUpSearchIPAddressClick(Sender: TObject);
var
    IP : string;
begin

    // sk

    // frst ipnummret
    IP := TListView(ActiveControl).Selected.SubItems.Strings[0];

    // skicka till skformulret
    frmFind.show;
    frmFind.txtFind.Text := IP;
    frmFind.btnStartSearch.Click;


end;

procedure TfrmStats.mnuPopUp2SearchNameClick(Sender: TObject);
var
    name : string;

begin

    name := TListView(ActiveControl).Selected.SubItems.Strings[0];

    // skicka till skformulret
    frmFind.show;
    frmFind.txtFind.Text := name;
    frmFind.btnStartSearch.Click;

end;

procedure TfrmStats.FormActivate(Sender: TObject);
var
    filen : TIniFile;
begin

    // fult som fan antar jag, men det funkar:
    // byt meny p huvudformulret till en likadan meny fast utan kortkommandon - annars fr jag inte kortkommandona p detta formulr att funka :(
    frmMain.Menu := frmMain.MenuEmpty;


   // kolla om det r frsta gngen formulret visas
   // om det r det s ska vi ndra (eventuellt) storleken p fnstret
   if gHasBeenShown = false then begin

       // ls in instllningar
       filen := TIniFile.Create(gProgramPath + 'TinyLogger.ini');

       // ls in och stt storlek
       frmStats.Left:=filen.ReadInteger('StatsWindow','WindowPosLeft',75);
       frmStats.Top:=filen.ReadInteger('StatsWindow','WindowPosTop',75);
       frmStats.Width:=filen.ReadInteger('StatsWindow','WindowPosWidth',573);
       frmStats.Height:=filen.ReadInteger('StatsWindow','WindowPosHeight',569);

       gHasBeenShown := true;

       filen.free;

   end;

end;



procedure TfrmStats.UppdateraStats;
begin

    screen.Cursor := crHourGlass;

    frmStats.ListViewRule.Items.BeginUpdate;
    frmStats.ListViewProtocol.Items.BeginUpdate;
    frmStats.ListViewSourceAddress.Items.BeginUpdate;
    frmStats.ListViewSourcePort.Items.BeginUpdate;
    frmStats.ListViewDestinationAddress.Items.BeginUpdate;
    frmStats.ListViewDestinationPort.Items.BeginUpdate;

    // tm listviews'arna
    frmStats.ListViewRule.Clear;
    frmStats.ListViewProtocol.Clear;
    frmStats.ListViewSourceAddress.Clear;
    frmStats.ListViewSourcePort.Clear;
    frmStats.ListViewDestinationAddress.Clear;
    frmStats.ListViewDestinationPort.Clear;

    // lgg in i listviews'arna
    ProgressBar.Position := 15;
    getStats(3, frmStats.ListViewRule);
    ProgressBar.Position := ProgressBar.Position + 15;
    getStats(4, frmStats.ListViewProtocol);
    ProgressBar.Position := ProgressBar.Position + 15;
    getStats(5, frmStats.ListViewSourceAddress);
    ProgressBar.Position := ProgressBar.Position + 15;
    getStats(6, frmStats.ListViewSourcePort);
    ProgressBar.Position := ProgressBar.Position + 15;
    getStats(7, frmStats.ListViewDestinationAddress);
    ProgressBar.Position := ProgressBar.Position + 15;
    getStats(8, frmStats.ListViewDestinationPort);
    ProgressBar.Position := 100;

    // sortera
    ListViewRule.CustomSort(@CustomSortProc, 0);
    ListViewProtocol.CustomSort(@CustomSortProc, 0);
    ListViewSourceAddress.CustomSort(@CustomSortProc, 0);
    ListViewSourcePort.CustomSort(@CustomSortProc, 0);
    ListViewDestinationAddress.CustomSort(@CustomSortProc, 0);
    ListViewDestinationPort.CustomSort(@CustomSortProc, 0);
    ListViewDestinationPort.CustomSort(@CustomSortProc, 0);

    frmStats.ListViewRule.Items.EndUpdate;
    frmStats.ListViewProtocol.Items.EndUpdate;
    frmStats.ListViewSourceAddress.Items.EndUpdate;
    frmStats.ListViewSourcePort.Items.EndUpdate;
    frmStats.ListViewDestinationAddress.Items.EndUpdate;
    frmStats.ListViewDestinationPort.Items.EndUpdate;

    screen.Cursor := crDefault;
end;




procedure TfrmStats.Button2Click(Sender: TObject);
begin
    self.Close;
end;


// sker p name vid dubbelklick p listview
// sender = listview'n som man dubbelclickar p, inColumn avgr i vilken col. man ska ska i skfnstret
procedure TfrmStats.doubleClickSearch(sender: TObject; inColumn : integer);
var
    name : string;
begin

    // kontrollera att ngot r valt i ActiveControl, crash annars
    if TListView(ActiveControl).SelCount > 0 then begin

      // hmta in texten att ska efter
      name := TListView(ActiveControl).Selected.SubItems.Strings[0];

      // skicka till skformulret
      frmFind.show;
      frmFind.txtFind.Text := name; // text att ska
      frmFind.cbCols.ItemIndex := inColumn;  // mer specifikt; vad att ska
      frmFind.btnStartSearch.Click;
    end;

end;


procedure TfrmStats.ListViewRuleDblClick(Sender: TObject);
begin
    // sk
    doubleClickSearch(Sender, 4);
end;

procedure TfrmStats.ListViewProtocolDblClick(Sender: TObject);
begin
    // sk
    doubleClickSearch(Sender, 5);
end;

procedure TfrmStats.ListViewSourceAddressDblClick(Sender: TObject);
begin
    // sk
    doubleClickSearch(Sender, 6);
end;

procedure TfrmStats.ListViewSourcePortDblClick(Sender: TObject);
begin
    // sk
    doubleClickSearch(Sender, 7);
end;

procedure TfrmStats.ListViewDestinationAddressDblClick(Sender: TObject);
begin
    // sk
    doubleClickSearch(Sender, 8);
end;

procedure TfrmStats.ListViewDestinationPortDblClick(Sender: TObject);
begin
     // sk
    doubleClickSearch(Sender, 9);
end;

// aktiverar popup-menyerna om ngot r valt i listboxe
procedure TfrmStats.activeMenusIfSomethingIsChosen(Sender: TObject);
begin

    // ngot valt?
    if TListView(Sender).SelCount > 0 then begin
        // jepp, aktivera menyvalen
//        showmessage('nt r valt');
        mnuPopupMenu1.Items.Items[0].Enabled := true;
        mnuPopupMenu1.Items.Items[1].Enabled := true;
        mnuPopupMenu2.Items.Items[0].Enabled := true;
        mnuPopupMenu2.Items.Items[1].Enabled := true;
    end
    else begin
        // inaktivera menyerna
        mnuPopupMenu1.Items.Items[0].Enabled := false;
        mnuPopupMenu1.Items.Items[1].Enabled := false;
        mnuPopupMenu2.Items.Items[0].Enabled := false;
        mnuPopupMenu2.Items.Items[1].Enabled := false;

    end;


end;


procedure TfrmStats.ListViewRuleContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);
end;

procedure TfrmStats.ListViewProtocolContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);

end;

procedure TfrmStats.ListViewSourceAddressContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);

end;

procedure TfrmStats.ListViewSourcePortContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);

end;

procedure TfrmStats.ListViewDestinationAddressContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);

end;

procedure TfrmStats.ListViewDestinationPortContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
    // skicka vidare
    activeMenusIfSomethingIsChosen(Sender);

end;

end.
