unit Tools;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdEcho, IdRawBase, IdRawClient, IdIcmpClient,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdWhois,
  Psock, NMEcho, ComCtrls, ExtCtrls, IdDateTimeStamp, IdUDPBase,
  IdUDPClient, IdDNSResolver, NMHttp, OleCtrls, SHDocVw, Winsock,
  IdAntiFreezeBase, IdAntiFreeze;

type
  TfrmTools = class(TForm)
    Whois: TIdWhois;
    PageControl: TPageControl;
    TabPing: TTabSheet;
    TabTracert: TTabSheet;
    txtPingHost: TEdit;
    txtPingTTL: TEdit;
    txtPingRecieveTimeout: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnPingStart: TButton;
    txtPingPingsToSend: TEdit;
    Label4: TLabel;
    txtPingDelay: TEdit;
    Label5: TLabel;
    btnPingStop: TButton;
    GroupBox1: TGroupBox;
    MemoPing: TMemo;
    GroupBox2: TGroupBox;
    MemoTracert: TMemo;
    btnTracertStart: TButton;
    btnTracertStop: TButton;
    Label8: TLabel;
    txtTracertRecieveTimeout: TEdit;
    Label6: TLabel;
    txtTracertHost: TEdit;
    Label7: TLabel;
    txtTracertMaxHops: TEdit;
    icmpTracert: TIdIcmpClient;
    TracertTimer: TTimer;
    DNSresolver: TIdDNSResolver;
    icmpPing: TIdIcmpClient;
    PingTimer: TTimer;
    TabDNSResolver: TTabSheet;
    TabWhoIs: TTabSheet;
    HTTP: TNMHTTP;
    btnDNSIP2HostName: TButton;
    cbTracertResolveHostnames: TCheckBox;
    txtDNSIPAddress: TEdit;
    txtDNSHostName: TEdit;
    btnDNSHostName2IP: TButton;
    Label9: TLabel;
    Label10: TLabel;
    procedure btnDNSIP2HostNameClick(Sender: TObject);
    procedure icmpPingReply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
    procedure btnPingStartClick(Sender: TObject);
    procedure PingTimerTimer(Sender: TObject);
    procedure btnPingStopClick(Sender: TObject);
    procedure btnTracertStartClick(Sender: TObject);
    procedure icmpTracertReply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
    procedure btnSamSpadeStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnDNSHostName2IPClick(Sender: TObject);
    procedure txtDNSIPAddressEnter(Sender: TObject);
    procedure txtDNSHostNameEnter(Sender: TObject);
    procedure txtDNSIPAddressExit(Sender: TObject);
    procedure txtDNSHostNameExit(Sender: TObject);
    procedure TracertTimerTimer(Sender: TObject);
    procedure btnTracertStopClick(Sender: TObject);
  private
    { Private declarations }
    WSData: WSAData; // nt som har med starten av winsock att gra, tror jag
  public
    { Public declarations }
  end;

var
  frmTools: TfrmTools;



function translateIP2HostName( inIP:string ) : string;
function translateHostName2IP( inHost:string ) : string;



implementation

uses IdGlobal, strUtils;

// formulrglobala variabler
type
    ping = record
        send     : integer;
        recieved : integer;
        minMS    : integer;
        maxMS    : integer;
    end;
var
    gPing : ping;
    gTracertCurrentIP : string;
    gTracertCurrentTTL : integer;


{$R *.dfm}

procedure TfrmTools.btnDNSIP2HostNameClick(Sender: TObject);
begin

    screen.Cursor := crHourGlass;
    self.txtDNSHostName.text := translateIP2HostName( self.txtDNSIPAddress.text ) ;
    screen.Cursor := crDefault;

end;

procedure TfrmTools.icmpPingReply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
var
    svar : TReplyStatusTypes;
begin

//memo.clear;

svar := AReplyStatus.ReplyStatusType;

if svar = rsEcho then
    memoPing.Lines.Add( 'Status: An Echo was received. Answer from ' + AReplyStatus.FromIpAddress + ': byte=' + IntToStr(AReplyStatus.BytesReceived) + ' time ' +  IntToStr(areplystatus.MsRoundTripTime) + 'ms TTL=' + IntToStr(AReplyStatus.TimeToLive)  )
else if svar = rsError then
    memoPing.Lines.Add( 'Status: An error has occurred.' )
else if svar = rsTimeOut then
    memoPing.Lines.Add( 'Status: Timeout occurred before a response was received.' )
else if svar = rsErrorUnreachable then
    memoPing.Lines.Add( 'Status: The address for the ICMP message is not available.' )
else if svar = rsErrorTTLExceeded then
    memoPing.Lines.Add( 'Status: Time-To-Live exceeded for an ICMP response.' )
else
    memoPing.Lines.Add( 'Status: Unknown.' );

// hll reda p status
gPing.send := gPing.send + 1;
if svar = rsEcho then
    gPing.recieved := gPing.recieved + 1;
if AReplyStatus.MsRoundTripTime < gPing.minMS then
    gPing.minMS := AReplyStatus.MsRoundTripTime;
if AReplyStatus.MsRoundTripTime > gPing.maxMS then
    gPing.maxMS := AReplyStatus.MsRoundTripTime;

{
memo.Lines.Add( 'BytesReceived: ' + IntToStr(AReplyStatus.BytesReceived) );
memo.Lines.Add( 'MsRoundTripTime: ' + IntToStr(areplystatus.MsRoundTripTime) );
}
//memo.Lines.Add( '' );

{
    rsEcho - An Echo was received.
	rsError - An error has occurred.
	rsTimeOut - Timeout occurred before a response was received.
	rsErrorUnreachable - The address for the ICMP message is not available.
	rsErrorTTLExceeded - Time-To-Live exceeded for an ICMP response.
}



end;

procedure TfrmTools.btnPingStartClick(Sender: TObject);
var i : integer;
begin

// visa att vi jobbar
screen.Cursor := crHourGlass;

// inaktivera knappen start
btnPingStart.Enabled := false;
// aktivera knappen stop
btnPingstop.Enabled  := true;

// hur lnge mellan varje ping
PingTimer.Interval := StrToInt(txtPingDelay.text);

// antal gnger
PingTimer.Tag := StrToInt(txtPingPingsToSend.text);
// host att pinga
icmpPing.Host           := txtPingHost.Text;
// live for how long..?
icmpPing.TTL            := StrToInt(txtPingTTL.text);
// timeout fr pingningen
icmpPing.ReceiveTimeout := StrToInt(frmtools.txtPingRecieveTimeout.text);

// nollstll statisik
gPing.send      := 0;
gPing.recieved  := 0;
gPing.minMS     := 10000;
gPing.maxMS     := 0;


// rensa memo'n
memoPing.Clear;
// skriv att vi brjar pinga
MemoPing.Lines.Add('Pinging ' + txtPingHost.Text + ':');
MemoPing.Lines.Add('');

// frsta ping'en sker direkt..resten via timern
icmpPing.Ping;

// starta timern
PingTimer.Enabled := true;

end;

procedure TfrmTools.PingTimerTimer(Sender: TObject);
begin

    // pinga tills vi PingTimer.tag = 0
    if PingTimer.tag > 1 then
    begin
        // pinga..
        icmpPing.Ping;
        // minsta PingTimer.tag
        PingTimer.tag := PingTimer.tag - 1;

        // Kolla om vi nu r fdig.. s vi inte slipper vnta en intervall till
        if PingTimer.tag <= 1 then begin
            PingTimer.Interval := 1;
        end;

    end
    else
    begin
        // stng av timern
        PingTimer.Enabled := false;
        // skriv statistik
        memoPing.Lines.Add('');
        memoPing.Lines.Add('Packets: send = ' + IntToStr(gPing.send) + ', Recieved = ' + IntToStr(gPing.recieved) + ', Lost = ' + IntToStr(gPing.send-gPing.recieved) );
        memoPing.Lines.Add('Time: Minimum = ' + IntToStr(gPing.minMS) + 'ms, Maximum = ' + IntToStr(gPing.maxMS) ); 
        // enable'a knappen igen
        btnPingStart.Enabled := true;
        // disable'a stop-knappen
        btnPingStop.Enabled := false;
        // muspekare till standard igen
        Screen.Cursor := CrDefault;

    end;




end;

procedure TfrmTools.btnPingStopClick(Sender: TObject);
begin

    // tag till 0 s den stoppar...
    PingTimer.Tag := 0;
    // intevall till 1 = snabbt... (s vi slipper vnta p stoppningen)
    PingTimer.Interval := 1;

end;

procedure TfrmTools.btnTracertStartClick(Sender: TObject);
var currentTTL, i: integer;
    maxHops : integer;
begin

screen.Cursor := crHourGlass;

memoTracert.Clear;
memoTracert.Repaint;

icmpTracert.Host := txtTracertHost.Text;
icmptracert.ReceiveTimeout := StrToInt(frmTools.txtTracertRecieveTimeout.Text);

maxHops := StrToInt(txtTracertMaxHops.text);

// aktuellt ip, "falskt" frn brjan
gTracertCurrentIP := 'x.x.x.x';

// skriv att vi brjar trace'a
//memoTracert.Lines.Add('Tracing route to ' + translateIP2HostName(icmpTracert.Host) + '[' + icmpTracert.Host + ']');
memoTracert.Lines.Add('Tracing route to [' + icmpTracert.Host + ']');
memoTracert.Lines.Add('Over a maximum of ' + IntToStr(maxHops) + ' hops');
memoTracert.Lines.Add('');

// aktivera stoppa knappen
btnTracertStop.Enabled := true;
// inaktivera start knappen
btnTracertStart.Enabled := false;

// vi brjar med en Time To Live p 1
gTracertCurrentTTL := 1;

// starta timern
TracertTimer.Tag := 1;
TracertTimer.Enabled := true;

end;

procedure TfrmTools.icmpTracertReply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
var
    svar : TReplyStatusTypes;
begin

    svar := AReplyStatus.ReplyStatusType;

    // r frra ip-adressen lika som den nya s r vi framme (ehrm..fr man anta...)
    if gTracertCurrentIP = AReplyStatus.FromIpAddress then begin
        icmpTracert.Host := gTracertCurrentIP;
    end
    else
    begin
        // skriv ut och uppdatera aktuell ip-adress
        gTracertCurrentIP := AReplyStatus.FromIpAddress;
        // skriv i memo'n vad som hnder
        if svar = rsEcho then begin
            // rsEcho mste ju betyda att vi r framme
            // visa Host Name eller icke
            if cbTracertResolveHostnames.Checked = true then begin
                memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + #9 + '[' + translateIP2HostName(AReplyStatus.FromIpAddress) + '] ' + AReplyStatus.FromIpAddress);
            end
            else begin
                memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + #9 + AReplyStatus.FromIpAddress);
            end;

        end
        else if svar = rsError then begin
            memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + '   ' +  'Status: An error has occurred.' );
        end
        else if svar = rsTimeOut then begin
            memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + '   ' +  'Status: Timeout occurred before a response was received.' );
        end
        else if svar = rsErrorUnreachable then begin
            memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + '   ' +  'Status: The address for the ICMP message is not available.' );
        end
        else if svar = rsErrorTTLExceeded then begin
            // visa Host Name eller icke
            if cbTracertResolveHostnames.Checked = true then begin
                memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + #9 + '[' + translateIP2HostName(AReplyStatus.FromIpAddress) + '] ' + AReplyStatus.FromIpAddress);
            end
            else begin
                memoTracert.Lines.Add( IntToStr(memoTracert.Lines.count-2) + #9 + AReplyStatus.FromIpAddress);
            end;
        end;


    end;

    
end;

procedure TfrmTools.btnSamSpadeStartClick(Sender: TObject);
var
    tmp : string;
begin


// frsk hmta www.af.. men gissa! :^)
http.Get('http://samspade.org/t/lookat?a=smtphost1.home.se');



end;



// tar in ett IP-nummer  ger tebax domnamnet
// verkar funka..mindre koll p vad jag gr dock :/
function translateIP2HostName( inIP:string ) : string;
var
    addr : in_addr;
    p: PHostEnt;
    nr : integer;
{
struct hostent
    char FAR *       h_name;
    char FAR * FAR * h_aliases;
    short            h_addrtype;
    short            h_length;
    char FAR * FAR * h_addr_list;
}
begin

// mste kolla om det r ip frst dra...
// bl va trist

// ta reda p sifforna..
with addr.S_un_b do
  begin
    nr := StrToInt( Copy(inIP, 0, AnsiPos('.', inIP)-1 )); // frsta
    S_b1 := Char(nr);  // the first part as a byte (casted to a Char)


    inIP :=  Copy(inIP, AnsiPos('.', inIP)+1, 20); // ta bort frsta;
    nr := StrToInt( Copy(inIP, 0, AnsiPos('.', inIP)-1 )); // andra
    S_b2 := Char(nr);    // the second part

    inIP :=  Copy(inIP, AnsiPos('.', inIP)+1, 20); // ta bort andra;
    nr := StrToInt( Copy(inIP, 0, AnsiPos('.', inIP)-1 )); // trejde
    S_b3 := Char(nr);  // the third part

    inIP :=  Copy(inIP, AnsiPos('.', inIP)+1, 20); // ta bort tredje;
    nr := StrToInt(inIP);
    S_b4 := Char(nr);  // the last part
  end;                 // '194.18.100.100'

  // verstt IP -> host
  p := GetHostByAddr( @addr, 4, AF_INET);

  // lyckades det?
  if p=nil then
    // ShowMessage('Failed')   // e.g. if lookup fails. Call WSAGetLastError for error number.
    result := '0' // inget d allts...
  else
    // ShowMessage(p.h_name);  // as a test, display the name
    result := p.h_name;

end;


procedure TfrmTools.FormCreate(Sender: TObject);
begin

  // "starta" winsock
  if WSAStartup($0002, WSData) <> 0 then
    ShowMessage('WinSock initialisation failed');

end;

procedure TfrmTools.FormDestroy(Sender: TObject);
begin

    WSACleanup;

end;


// verstter HostName's till IP.
// frga min inte hur det funkar. "Hur funkar det?" "Frga inte sa jag!"
function translateHostName2IP( inHost:string ) : string;
var
    HostInfo        : PHostEnt;
//    HostAddressInfo : PaPInAddr;
    tmp : string;
    p2 : pchar;

begin

    // mumbo!
    HostInfo := GetHostByName( PChar(inHost) );

    //p2 := iNet_ntoa(PInAddr(p^.h_addr_list^)^);
    p2 := iNet_ntoa(PInAddr(HostInfo^.h_addr_list^)^);

    Result := p2;

end;



procedure TfrmTools.btnDNSHostName2IPClick(Sender: TObject);
begin
    screen.Cursor              := crHourGlass;
    self.txtDNSIPAddress.Text  := translateHostName2IP( self.txtDNSHostName.Text );
    screen.Cursor              := crDefault;
end;

procedure TfrmTools.txtDNSIPAddressEnter(Sender: TObject);
begin

    // gr knappen under till default
    self.btnDNSIP2HostName.Default := true;

end;

procedure TfrmTools.txtDNSHostNameEnter(Sender: TObject);
begin

    // gr knappen under till default
    self.btnDNSHostName2IP.Default := true;

end;

procedure TfrmTools.txtDNSIPAddressExit(Sender: TObject);
begin

    // gr knappen under till icke-default
    self.btnDNSIP2HostName.Default := false;

end;

procedure TfrmTools.txtDNSHostNameExit(Sender: TObject);
begin

    // gr knappen under till icke-default
    self.btnDNSHostName2IP.Default := false;

end;

procedure TfrmTools.TracertTimerTimer(Sender: TObject);
begin

// kra? r tag = 0 s ska det avbrytas
if TracertTimer.Tag > 0 then begin

    // pinga tills antal hop r fr mnga eller vi har kommit till slutadressen
    if (gTracertCurrentIP = icmpTracert.Host) or (gTracertCurrentTTL = StrToInt(txtTracertMaxHops.text)) then begin
        // klart!
        memoTracert.Lines.Add('');
        memoTracert.Lines.Add('Trace complete.');
        // stng av timer
        TracertTimer.Enabled := false;
        screen.Cursor := crDefault;
        // knappar till standardvrden
        btnTracertStart.Enabled := true; // aktivera start-knappen igen
        btnTracertStop.Enabled := false;
    end
    else begin
        // trace'a!
        icmpTracert.TTL := gTracertCurrentTTL;
        frmTools.Repaint;
        icmpTracert.Ping;
        frmTools.Repaint;
        inc(gTracertCurrentTTL);
    end;

end
else begin
    // stoppa
    TracertTimer.Enabled := false;
    // skriv att vi avbrt
    memoTracert.Lines.Add('');
    memoTracert.Lines.Add('Trace was stopped by the user.');
    // muspekare till standard igen
    Screen.Cursor := CrDefault;
    // knappar till standardvrden
    btnTracertStart.Enabled := true; // aktivera start-knappen igen
    btnTracertStop.Enabled := false;
end;



end;

procedure TfrmTools.btnTracertStopClick(Sender: TObject);
begin
    TracertTimer.Tag := 0; // bertta fr timern att vi vill stoppa den
    TracertTimer.Interval := 1; // inte behva vnta p klockan
end;

end.
